/*-----------------------------------------------------------------------------
	{WinMain.h]

	Copyright (C) 2004 Ki

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-----------------------------------------------------------------------------*/
#ifndef WINMAIN_H_INCLUDED
#define WINMAIN_H_INCLUDED

#include "TypeDefs.h"


//KitaoǉBMAINCAPTION͑g悤ɂ̂łŒ`
#ifdef DEBUGBUILD
#define MAINCAPTION		"Ootake DEBUG BUILD " __DATE__
#else
#define MAINCAPTION		"Ootake"
#endif


enum UserDefinedWM
{
	WM_SET_FULLSCREEN_WS = WM_APP,
	WM_SET_NORMAL_WS,
};

/* j[R}h 100 ` */
enum MenuCommand
{
	WM_TRACE_1_FRAME = 100,
	WM_TRACE_10_FRAME,
	WM_TRACE_100_FRAME,
	WM_OPEN_FILE,
	WM_CD_CHANGE, //Kitaoǉ
	WM_RESET_EMULATOR,
	WM_RUN_EMULATOR,
	WM_STOP_EMULATOR,
	WM_SET_RESUME, //Kitaoǉ
	WM_SAVE_STATE,
	WM_SAVE_STATE_1, //Kitaoǉ
	WM_SAVE_STATE_2, //Kitaoǉ
	WM_SAVE_STATE_3, //Kitaoǉ
	WM_SAVE_STATE_4, //Kitaoǉ
	WM_SAVE_STATE_5, //Kitaoǉ
	WM_SAVE_STATE_6, //Kitaoǉ
	WM_SAVE_STATE_7, //Kitaoǉ
	WM_SAVE_STATE_8, //Kitaoǉ
	WM_SAVE_STATE_9, //Kitaoǉ
	WM_SAVE_STATE_10, //Kitaoǉ
	WM_SAVE_STATE_11, //Kitaoǉ
	WM_SAVE_STATE_12, //Kitaoǉ
	WM_SAVE_STATE_13, //Kitaoǉ
	WM_SAVE_STATE_14, //Kitaoǉ
	WM_SAVE_STATE_15, //Kitaoǉ
	WM_SAVE_STATE_16, //Kitaoǉ
	WM_SAVE_STATE_17, //Kitaoǉ
	WM_SAVE_STATE_18, //Kitaoǉ
	WM_SAVE_STATE_19, //Kitaoǉ
	WM_SAVE_STATE_20, //Kitaoǉ
	WM_LOAD_STATE,
	WM_LOAD_STATE_P, //Kitaoǉ
	WM_LOAD_STATE_1, //Kitaoǉ
	WM_LOAD_STATE_2, //Kitaoǉ
	WM_LOAD_STATE_3, //Kitaoǉ
	WM_LOAD_STATE_4, //Kitaoǉ
	WM_LOAD_STATE_5, //Kitaoǉ
	WM_LOAD_STATE_6, //Kitaoǉ
	WM_LOAD_STATE_7, //Kitaoǉ
	WM_LOAD_STATE_8, //Kitaoǉ
	WM_LOAD_STATE_9, //Kitaoǉ
	WM_LOAD_STATE_10, //Kitaoǉ
	WM_LOAD_STATE_11, //Kitaoǉ
	WM_LOAD_STATE_12, //Kitaoǉ
	WM_LOAD_STATE_13, //Kitaoǉ
	WM_LOAD_STATE_14, //Kitaoǉ
	WM_LOAD_STATE_15, //Kitaoǉ
	WM_LOAD_STATE_16, //Kitaoǉ
	WM_LOAD_STATE_17, //Kitaoǉ
	WM_LOAD_STATE_18, //Kitaoǉ
	WM_LOAD_STATE_19, //Kitaoǉ
	WM_LOAD_STATE_20, //Kitaoǉ
	WM_FOLDER_STATE, //Kitaoǉ
	WM_RECORD_GAMEPLAY,
	WM_PLAYBACK_GAMEPLAY,
	WM_FOLDER_GAMEPLAY, //Kitaoǉ
	WM_FOLDER_BRAM, //Kitaoǉ

	WM_RECENT_1, //Kitaoǉ
	WM_RECENT_2, //Kitaoǉ
	WM_RECENT_3, //Kitaoǉ
	WM_RECENT_4, //Kitaoǉ
	WM_RECENT_5, //Kitaoǉ
	WM_RECENT_6, //Kitaoǉ
	WM_RECENT_7, //Kitaoǉ
	WM_RECENT_8, //Kitaoǉ
	WM_RECENT_9, //Kitaoǉ
	WM_RECENT_10, //Kitaoǉ
	WM_RECENT_11, //Kitaoǉ
	WM_RECENT_12, //Kitaoǉ
	WM_RECENT_13, //Kitaoǉ
	WM_RECENT_14, //Kitaoǉ
	WM_RECENT_15, //Kitaoǉ
	WM_RECENT_16, //Kitaoǉ
	WM_RECENT_17, //Kitaoǉ
	WM_RECENT_18, //Kitaoǉ
	WM_RECENT_19, //Kitaoǉ
	WM_RECENT_20, //Kitaoǉ

	WM_SCREEN_X1,
	WM_SCREEN_X2,
	WM_SCREEN_X3,
	WM_SCREEN_X4,
	WM_SCREEN_F1,
	WM_SCREEN_F2,
	WM_SCREEN_GAMMA1,
	WM_SCREEN_GAMMA2,
	WM_SCREEN_GAMMA3,
	WM_SCREEN_GAMMA4,
	WM_SCREEN_GAMMA5,
	WM_SCREEN_MINIMIZE, //Kitaoǉ
	WM_SCREEN_NONSTRETCHED, //Kitaoǉ
	WM_SCREEN_STRETCHED,
	WM_SCREEN_VERTICAL, //Kitaoǉ
	WM_SCREEN_TV, //Kitaoǉ

	WM_INPUT_TWO_BUTTON_PAD,
	WM_INPUT_THR_BUTTON_PAD, //Kitaoǉ
	WM_INPUT_SIX_BUTTON_PAD,
	WM_INPUT_MOUSE,
	WM_INPUT_MULTI_TAP,
	WM_INPUT_MB128,
	WM_INPUT_SWAP_SELRUN, //Kitaoǉ
	WM_INPUT_SWAP_IANDII, //Kitaoǉ
	WM_INPUT_TURBO_1, //Kitaoǉ
	WM_INPUT_TURBO_2, //Kitaoǉ
	WM_INPUT_TURBO_RUN, //Kitaoǉ
	WM_INPUT_TURBO_HIGH, //Kitaoǉ
	WM_INPUT_TURBO_MIDDLE, //Kitaoǉ
	WM_INPUT_TURBO_LOW, //Kitaoǉ
	WM_INPUT_TURBO_OFF, //Kitaoǉ

	WM_INPUT_CONFIGURE_PAD1,
	WM_INPUT_CONFIGURE_PAD2,
	WM_INPUT_CONFIGURE_PAD3,
	WM_INPUT_CONFIGURE_PAD4,
	WM_INPUT_CONFIGURE_PAD5,
	WM_INPUT_CONFIGURE_TB1,
	WM_INPUT_CONFIGURE_TB2,
	WM_INPUT_CONFIGURE_TB3,
	WM_INPUT_CONFIGURE_TB4,
	WM_INPUT_CONFIGURE_TB5,
	WM_INPUT_CONFIGURE_INIT, //Kitaoǉ

	WM_SCREEN_FULLSCREEN,
	WM_SCREEN_FULLSCREEN640, //Kitaoǉ
	WM_SCREEN_NONSCANLINED, //Kitaoǉ
	WM_SCREEN_SCANLINED,
	WM_SCREEN_HRSCANLINED, //Kitaoǉ
	WM_SCREEN_STARTTV, //Kitaoǉ
	WM_SCREEN_SCANDENSITY0, //Kitaoǉ
	WM_SCREEN_SCANDENSITY20, //Kitaoǉ
	WM_SCREEN_SCANDENSITY40, //Kitaoǉ
	WM_SCREEN_SCANDENSITY80, //Kitaoǉ
	WM_SCREEN_HWACCEL,
	WM_SCREEN_SYNC_VBLANK,
	WM_SCREEN_FULL16BITCOLOR, //Kitaoǉ
	WM_SCREEN_FULL32BITCOLOR, //Kitaoǉ
	WM_SCREEN_STARTWINDOW, //Kitaoǉ
	WM_SCREEN_STARTFULL, //Kitaoǉ
	WM_SCREEN_ACTIVATE, //Kitaoǉ
	WM_SCREEN_NONACTIVATE, //Kitaoǉ

	WM_AUDIO_SR96000,		/* not supported */
	WM_AUDIO_SR88200,		/* not supported */
	WM_AUDIO_SR64000,
	WM_AUDIO_SR48000,
	WM_AUDIO_SR44100,
	WM_AUDIO_SR32000,
	WM_AUDIO_SR22050,
	WM_AUDIO_SR11025,

	WM_AUDIO_SB1024, //KitaoXV
	WM_AUDIO_SB1536,
	WM_AUDIO_SB1792,
	WM_AUDIO_SB2048,
	WM_AUDIO_SB2304,
	WM_AUDIO_SB2560,
	WM_AUDIO_SB3072,
	WM_AUDIO_SB3584,
	WM_AUDIO_SB4096,

	WM_AUDIO_STEREO, //Kitaoǉ
	WM_AUDIO_MONO, //Kitaoǉ

	WM_AUDIO_INI1, //Kitaoǉ
	WM_AUDIO_INI2, //Kitaoǉ
	WM_AUDIO_INI3, //Kitaoǉ

	WM_AUDIO_SETVOLUME,
	WM_AUDIO_DEFAULTVOLUME, //Kitaoǉ
	WM_VOLUME_NORMAL, //Kitaoǉ
	WM_VOLUME_HALF, //Kitaoǉ
	WM_VOLUME_QUARTER, //Kitaoǉ
	WM_VOLUME_MUTE, //Kitaoǉ
	WM_VOLUME_NORMALBUFFER, //Kitaoǉ
	WM_VOLUME_BIGBUFFER, //Kitaoǉ
	WM_VOLUME_MOSTBUFFER, //Kitaoǉ

	WM_INFO_TESTDELAY, //Kitaoǉ
	WM_INFO_MANUENGLISH, //Kitaoǉ
	WM_INFO_MANUJAPANESE, //Kitaoǉ
	WM_INFO_README, //Kitaoǉ
	WM_INFO_HOMEPAGE, //Kitaoǉ
	WM_INFO_VERSION, //Kitaoǉ

	WM_DEVICE_CD0, //Kitaoǉ
	WM_DEVICE_CD1, //Kitaoǉ
	WM_DEVICE_CD2, //Kitaoǉ
	WM_DEVICE_CD3, //Kitaoǉ
	WM_DEVICE_CD4, //Kitaoǉ
	WM_DEVICE_CD5, //Kitaoǉ
	WM_DEVICE_CD6, //Kitaoǉ
	WM_DEVICE_CD7, //Kitaoǉ
	WM_DEVICE_CD8, //Kitaoǉ
	WM_DEVICE_CD9, //Kitaoǉ
	WM_CD_INSTALL, //Kitaoǉ
	WM_CD_UNINSTALL, //Kitaoǉ
	WM_CD_OPENINSTALL, //Kitaoǉ
	WM_CD_ARCADECARD, //Kitaoǉ
	WM_CD_SYSTEMCARD, //Kitaoǉ

	WM_CHANGE_CDC, //Kitaoǉ
	WM_CHANGE_CD0, //Kitaoǉ
	WM_CHANGE_CD1, //Kitaoǉ
	WM_CHANGE_CD2, //Kitaoǉ
	WM_CHANGE_CD3, //Kitaoǉ
	WM_CHANGE_CD4, //Kitaoǉ
	WM_CHANGE_CD5, //Kitaoǉ
	WM_CHANGE_CD6, //Kitaoǉ
	WM_CHANGE_CD7, //Kitaoǉ
	WM_CHANGE_CD8, //Kitaoǉ
	WM_CHANGE_CD9, //Kitaoǉ
	WM_F1_NORESET, //Kitaoǉ

	WM_STARTFASTCD_ON, //Kitaoǉ
	WM_STARTFASTCD_OFF, //Kitaoǉ
	WM_STARTFASTCD_PRE, //Kitaoǉ

	WM_STARTFASTSEEK_ON, //Kitaoǉ
	WM_STARTFASTSEEK_OFF, //Kitaoǉ
	WM_STARTFASTSEEK_PRE, //Kitaoǉ

	WM_AUTO_GRADIUS2, //Kitaoǉ
	WM_STARTSPRITE_OFF, //Kitaoǉ
	WM_STARTSPRITE_ON, //Kitaoǉ
	WM_STARTSPRITE_PRE, //Kitaoǉ

	WM_MENU_HIDEMENU, //Kitaoǉ
	WM_MENU_HIDEMESSAGE, //Kitaoǉ

	WM_POWER_FULLSPEED, //Kitaoǉ
	WM_POWER_POWERSAVING, //Kitaoǉ

	WM_SPEED_V0, //Kitaoǉ
	WM_SPEED_V1, //Kitaoǉ
	WM_SPEED_V2, //Kitaoǉ
	WM_SPEED_V3, //Kitaoǉ
	WM_SPEED_V4, //Kitaoǉ
	WM_SPEED_V5, //Kitaoǉ
	WM_SPEED_V6, //Kitaoǉ
	WM_SPEED_V7, //Kitaoǉ
	WM_SPEED_V8, //Kitaoǉ
	WM_SPEED_V9, //Kitaoǉ
	WM_SPEED_VAL, //Kitaoǉ
	WM_SPEED_VUSE, //Kitaoǉ
	WM_SPEED_VSET, //Kitaoǉ
	WM_SPEED_P0, //Kitaoǉ
	WM_SPEED_P1, //Kitaoǉ
	WM_SPEED_P2, //Kitaoǉ
	WM_SPEED_P3, //Kitaoǉ
	WM_SPEED_P4, //Kitaoǉ
	WM_SPEED_P5, //Kitaoǉ
	WM_SPEED_P6, //Kitaoǉ
	WM_SPEED_TURBO, //Kitaoǉ
	WM_SPEED_FASTCD, //Kitaoǉ
	WM_SPEED_FASTSEEK, //Kitaoǉ
	WM_SPEED_HELP, //Kitaoǉ

	WM_RASTERTIMING_MEARLY, //Kitaoǉ
	WM_RASTERTIMING_EARLY, //Kitaoǉ
	WM_RASTERTIMING_MIDDLE, //Kitaoǉ
	WM_RASTERTIMING_LATE, //Kitaoǉ
	WM_RASTERTIMING_MLATE, //Kitaoǉ

	WM_SUPERGRAFX, //Kitaoǉ
	WM_SPRITEOVER, //Kitaoǉ

	WM_BIT_CONVERT, //Kitaoǉ
	WM_SHOW_DEBUG, //Kitaoǉ

	WM_ALL_DEFAULT, //Kitaoǉ

	WM_EXIT,

	WM_SAVE_BMP,
};


extern int	__main__(int argc, char** argv);


const HINSTANCE	WINMAIN_GetHInstance();

inline const HWND
WINMAIN_GetHwnd();

void
WINMAIN_SetFullScreenWindow(
	Sint32		width,
	Sint32		height);
void
WINMAIN_SetNormalWindow(
	Sint32		width,
	Sint32		height);

void
WINMAIN_SetCaption(
	const char*		pCaption);

//Kitaoǉ
char*
WINMAIN_GetCaption();

Uint32
WINMAIN_ShowCursor(
	BOOL		bShow);


//KitaoǉBfobOp
void
WINMAIN_SetBreakTrap(
	BOOL bBrakTrap);

//KitaoǉBfobOp
BOOL
WINMAIN_GetBreakTrap();


#endif /* WINMAIN_H_INCLUDED */
